import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.Collections;


public class CMSC351PHW2driver {

	public static void main(String[] args) {
		CMSC351PHW2<Integer> runner = new CMSC351PHW2<Integer>();

		ArrayList<Integer> vals = new ArrayList<Integer>();
		int size = 8191;
		int target = size/2 + 1;
		for (int i=1; i<=size; i++) {
			vals.add(i);
		}

		for (int X=3; X<10; X+=2) {
			int trials=1000;
			for (int i=0; i<trials; i++) {
				Integer myMedian = runner.xMoM(vals, target, X);
				Collections.sort(vals);
				Integer realMedian = vals.get(target-1);
				assertEquals(realMedian, myMedian);
				Collections.shuffle(vals);
			}
			System.out.println(
					"X: "+ X + 
					"    Average # of Comparisons: " + (double)runner.getComps()/trials
			);
			runner.resetComps();
		}
	}
}
